> For the complete documentation index, see [llms.txt](https://docs.rierino.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.rierino.com/devops/api-event-and-process-flows/configuring-saga-steps/event-step/flow-actions/lock-and-unlock.md).

# Lock & Unlock

These actions provide ability to create locks and unlock them for a given id and a domain.

## Lock & Unlock Actions

### TryLock

Tries creating a lock and returns whether it was successful:

{% tabs %}
{% tab title="Fields (table)" %}

| Field          | Definition                                      | Example    | Default |
| -------------- | ----------------------------------------------- | ---------- | ------- |
| Input Element  | Json path in payload that has id parameter      | parameters | -       |
| Output Element | Json path in payload to return "locked" results | result     | -       |
| {% endtab %}   |                                                 |            |         |

{% tab title="Fields (JSON Schema)" %}

```json
{
  "$schema": "https://json-schema.org/draft/2020-12/schema",
  "type": "object",
  "properties": {
    "eventMeta": {
      "type": "object",
      "properties": {
        "inputElement": {
          "type": "string",
          "description": "Json path in payload that has id parameter",
          "examples": ["parameters"],
          "default": null
        },
        "outputElement": {
          "type": "string",
          "description": "Json path in payload to return \"locked\" results",
          "examples": ["result"],
          "default": null
        }
      }
    }
  }
}
```

{% endtab %}
{% endtabs %}

With the following event metadata parameters:

{% tabs %}
{% tab title="Parameters (table)" %}

| Parameter     | Definition                                                                                          | Example | Default |
| ------------- | --------------------------------------------------------------------------------------------------- | ------- | ------- |
| Master        | Whether master lock should be used instead of a specific id                                         | true    | false   |
| Timeout       | Milliseconds to wait for acquiring a lock, overrides default                                        | 2000    | -       |
| Expiry        | TTL in milliseconds for lock expiry, overrides default                                              | 10000   | -       |
| Allow No Lock | Whether failure to hold a lock should return a successful result, returns `locked` instead of error | true    | false   |
| {% endtab %}  |                                                                                                     |         |         |

{% tab title="Parameters (JSON Schema)" %}

```json
{
  "$schema": "https://json-schema.org/draft/2020-12/schema",
  "type": "object",
  "properties": {
    "eventMeta": {
      "type": "object",
      "properties": {
        "parameters": {
          "type": "object",
          "properties": {
            "master": {
              "type": "boolean",
              "description": "Whether master lock should be used instead of a specific id",
              "examples": [true],
              "default": false
            },
            "timeout": {
              "type": "integer",
              "description": "Milliseconds to wait for acquiring a lock (overrides default)",
              "examples": [2000],
              "default": null
            },
            "expiry": {
              "type": "integer",
              "description": "TTL in milliseconds for lock expiry (overrides default)",
              "examples": [10000],
              "default": null
            },
            "allowNoLock": {
              "type": "boolean",
              "description": "Whether failure to hold a lock should return a successful result (returns \"locked\" value instead of error)",
              "examples": [true],
              "default": false
            }
          }
        }
      }
    }
  }
}
```

{% endtab %}
{% endtabs %}

### Unlock

Unlocks an existing lock:

{% tabs %}
{% tab title="Fields (table)" %}

| Field         | Definition                                 | Example    | Default |
| ------------- | ------------------------------------------ | ---------- | ------- |
| Input Element | Json path in payload that has id parameter | parameters | -       |
| {% endtab %}  |                                            |            |         |

{% tab title="Fields (JSON Schema)" %}

```json
{
  "$schema": "https://json-schema.org/draft/2020-12/schema",
  "type": "object",
  "properties": {
    "eventMeta": {
      "type": "object",
      "properties": {
        "inputElement": {
          "type": "string",
          "description": "Json path in payload that has id parameter",
          "examples": ["parameters"],
          "default": null
        }
      }
    }
  }
}
```

{% endtab %}
{% endtabs %}

With the following event metadata parameters:

{% tabs %}
{% tab title="Parameters (table)" %}

| Parameter    | Definition                                                  | Example | Default |
| ------------ | ----------------------------------------------------------- | ------- | ------- |
| Master       | Whether master lock should be used instead of a specific id | true    | false   |
| {% endtab %} |                                                             |         |         |

{% tab title="Parameters (JSON Schema)" %}

```json
{
  "$schema": "https://json-schema.org/draft/2020-12/schema",
  "type": "object",
  "properties": {
    "eventMeta": {
      "type": "object",
      "properties": {
        "parameters": {
          "type": "object",
          "properties": {
            "master": {
              "type": "boolean",
              "description": "Whether master lock should be used instead of a specific id",
              "examples": [true],
              "default": false
            }
          }
        }
      }
    }
  }
}
```

{% endtab %}
{% endtabs %}

### CheckLock

Returns the current status for a lock:

{% tabs %}
{% tab title="Fields (table)" %}

| Field          | Definition                                      | Example    | Default |
| -------------- | ----------------------------------------------- | ---------- | ------- |
| Input Element  | Json path in payload that has id parameter      | parameters | -       |
| Output Element | Json path in payload to return "locked" results | result     | -       |
| {% endtab %}   |                                                 |            |         |

{% tab title="Fields (JSON Schema)" %}

```json
{
  "$schema": "https://json-schema.org/draft/2020-12/schema",
  "type": "object",
  "properties": {
    "eventMeta": {
      "type": "object",
      "properties": {
        "inputElement": {
          "type": "string",
          "description": "Json path in payload that has id parameter",
          "examples": ["parameters"],
          "default": null
        },
        "outputElement": {
          "type": "string",
          "description": "Json path in payload to return \"locked\" results",
          "examples": ["result"],
          "default": null
        }
      }
    }
  }
}
```

{% endtab %}
{% endtabs %}

With the following event metadata parameters:

{% tabs %}
{% tab title="Parameters (table)" %}

| Parameter    | Definition                                                  | Example | Default |
| ------------ | ----------------------------------------------------------- | ------- | ------- |
| Master       | Whether master lock should be used instead of a specific id | true    | false   |
| {% endtab %} |                                                             |         |         |

{% tab title="Parameters (JSON Schema)" %}

```json
{
  "$schema": "https://json-schema.org/draft/2020-12/schema",
  "type": "object",
  "properties": {
    "eventMeta": {
      "type": "object",
      "properties": {
        "parameters": {
          "type": "object",
          "properties": {
            "master": {
              "type": "boolean",
              "description": "Whether master lock should be used instead of a specific id",
              "examples": [true],
              "default": false
            }
          }
        }
      }
    }
  }
}
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.rierino.com/devops/api-event-and-process-flows/configuring-saga-steps/event-step/flow-actions/lock-and-unlock.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
